---
title: AudioBufferSourceNode.loopEnd
slug: Web/API/AudioBufferSourceNode/loopEnd
tags:
  - API
  - Audio
  - AudioBufferSourceNode
  - Media
  - Property
  - Reference
  - Web Audio API
  - loopEnd
  - sound
---
<p>{{ APIRef("Web Audio API") }}</p>

<div>
<p>The <code>loopEnd</code> property of the {{ domxref("AudioBufferSourceNode") }} interface specifies is a floating point number specifying, in seconds, at what offset into playing the {{domxref("AudioBuffer")}} playback should loop back to the time indicated by the {{domxref("AudioBufferSourceNode.loopStart", "loopStart")}} property. This is only used if the {{domxref("AudioBufferSourceNode.loop", "loop")}} property is <code>true</code>.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>AudioBufferSourceNode.loopEnd = endOffsetInSeconds</em>;

var <em>endOffsetInSeconds</em> = <em>AudioBufferSourceNode<code>.loopEnd;</code></em>
</pre>

<h3 id="Value">Value</h3>

<p>A floating-point number indicating the offset, in seconds, into the audio buffer at which each loop will loop return to the beginning of the loop (that is, the current play time gets reset to {{domxref("AudioBufferSourceNode.loopStart")}}). This property is only used if the {{domxref("AudioBufferSourceNode.loop", "loop")}} property is <code>true</code>.</p>

<p>The default value is 0.</p>

<h2 id="Example">Example</h2>

<p>In this example, the {{domxref("AudioContext.decodeAudioData()")}} function is used to decode an audio track and put it into an {{domxref("AudioBufferSourceNode")}}. Buttons are provided to play and stop the audio playback, and slider controls are used to change the <code>playbackRate</code>, <code>loopStart</code> and <code>loopEnd</code> properties on the fly.</p>

<p>When the audio is played to the end, it loops, but you can control how long the loops last by altering <code>loopStart</code> and <code>loopEnd</code>. For example, if you set their values to 20 and 25, respectively, then begin playback, the sound will play normally until it reaches the 25 second mark. Then the current play position will loop back to the 20 second mark and continue playing until the 25 second mark, ad infinitum (or at least until {{domxref("AudioBufferSourceNode.stop", "stop()")}} is called).</p>

<div class="note">
<p>For a full working example, see<a class="external external-icon" href="https://mdn.github.io/webaudio-examples/decode-audio-data/"> this code running live</a>, or <a class="external external-icon" href="https://github.com/mdn/webaudio-examples/tree/master/decode-audio-data">view the source</a>.</p>
</div>

<pre class="brush: js">function getData() {
  source = audioCtx.createBufferSource();
  request = new XMLHttpRequest();

  request.open('GET', 'viper.ogg', true);

  request.responseType = 'arraybuffer';

  request.onload = function() {
    var audioData = request.response;

    audioCtx.decodeAudioData(audioData, function(buffer) {
        myBuffer = buffer;
        songLength = buffer.duration;
        source.buffer = myBuffer;
        source.playbackRate.value = playbackControl.value;
        source.connect(audioCtx.destination);
        source.loop = true;

        loopstartControl.setAttribute('max', Math.floor(songLength));
        loopendControl.setAttribute('max', Math.floor(songLength));
      },

      function(e){"Error with decoding audio data" + e.err});

  }

  request.send();
}

  ...

loopstartControl.oninput = function() {
  source.loopStart = loopstartControl.value;
  loopstartValue.innerHTML = loopstartControl.value;
}

loopendControl.oninput = function() {
  source.loopEnd = loopendControl.value;
  loopendValue.innerHTML = loopendControl.value;
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Audio API', '#dom-audiobuffersourcenode-loopend', 'loopEnd')}}</td>
   <td>{{Spec2('Web Audio API')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.AudioBufferSourceNode.loopEnd")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Web_Audio_API">Web Audio API</a></li>
 <li><a href="/en-US/docs/Web/API/Web_Audio_API/Using_Web_Audio_API">Using the Web Audio API</a></li>
</ul>
